Doomsday Engine - Bug #1078

Patch texture composition logic errors
2012-08-25 02:28 - danij

Status: New Start date: 2012-08-25
Priority: High % Done: 0%
Assignee:

Category: Vanilla emulation

Target version: Vanilla / Gameplay

Description

Doomsday's Patch texture composition does not replicate the logic of the id tech 1 column/post based software renderer. In the
original renderer posts are automatically enlarged to encompass the full range of a Patch column. Therefore the actual dimensions of
textures in the Textures namespace aren't necessarily the same as those defined in (say) the TEXTURE1 lump, the real dimensions
are only known once the texture image is composite is built.

Looking at the code it would appear we already have some logic which attempts to do this with composites bound for use on the sky
dome. However, the logic there is flawed also because the logical dimensions of the texture remain the same and only the
dimensions of the uploaded image are adjusted.

See the attached test WAD for a concrete example of the failure case.

Labels: Data

Related issues:
Related to Bug #877: Texture offset anomaly New 2010-03-21

History

#1 - 2012-08-25 02:28 - danij

- status: open --> fixed

#2 - 2012-08-25 19:01 - skyjake

- milestone: v1.8.6 -->v1.9.10

#3 - 2012-08-25 20:02 - danij

Attachments:

e http://sourceforge.net/p/deng/bugs/_discuss/thread/5a047a51/da5c/attachment/testrail.wad

#4 - 2012-08-27 19:38 - danij

Further investigation revealed that there is in fact two issues here. The first being that the prepared image is not expanded as described in the initial
report. The second is that the logical Material dimensions similarly need to expand to match the Texture as these are what determine the relative
origin of middle textures on two-sided lines.

One solution would be an observer pattern -like mechanism (i.e., signals & slots in Qt parlance) whereby Materials are automatically notified when a
Texture's logical dimensions change. Obviously this is too radical for the imminent Doomsday v1.9.9 release (material_t is but an opaque C struct
presently) however it should be addressed early on for 1.9.10

#5 - 2012-12-10 07:42 - danij

- status: fixed --> open
- milestone: v1.9.10 --> v1.8.6

#6 - 2013-10-22 14:59 - skyjake
- Tags set to Textures
- Category set to Vanilla emulation

- Target version deleted (1.8.6)

#7 - 2017-04-03 14:43 - skyjake

- Target version set to Rendering
http://sourceforge.net/p/deng/bugs/_discuss/thread/5a047a51/da5c/attachment/testrail.wad

#8 - 2017-04-03 18:32 - skyjake

- Target version changed from Rendering to Vanilla/ Gameplay

#9 - 2019-11-29 23:06 - skyjake
- Assignee deleted (danij)
